'+---------------------------------------------------------------------+
'| dsprocs.inc                                                         |
'|                                                                     |
'| Prozeduren fr die einfache Verwendung von DirectSound mit Profan  |
'| Lauffhig ab Profan 7.0                                            |
'|                                                                     |
'| Autor: Sebastian Knig                                              |
'| email: feedback@sekoenig.de                                         |
'| Homepage: http://www.sekoenig.de                                    |
'| Copyright 2001 Sebastian Knig                                     |
'+---------------------------------------------------------------------+


DEF DirectSoundCreate(3) !"DSOUND","DirectSoundCreate"
DEF mmioOpen(3) !"WINMM","mmioOpenA"
DEF mmioRead(3) !"WINMM","mmioRead"
DEF mmioDescend(4) !"WINMM","mmioDescend"
DEF mmioAscend(3) !"WINMM","mmioAscend"
DEF mmioClose(2) !"WINMM","mmioClose"
'+++

declare IDirectSound&,DSBPrimary&
declare vp_dsound&,vp_primaryb&
declare DSBUFFERDESC#,WAVEFORMATEX#
declare child_MMCKINFO#,parent_MMCKINFO#
'+++

proc DSInit

 declare hr&

 let hr& = DirectSoundCreate(0,Addr(IDirectSound&),0)

 if @neq(hr&,0)
  return hr&
 endif

 let vp_dsound& = @long(IDirectSound&,0)
 let hr& = Call(@long(vp_dsound&,24),IDirectSound&,%hwnd,1) 'SetCooperativeLevel

 if @neq(hr&,0)
  return hr&
 endif

 dim DSBUFFERDESC#,20
 dim WAVEFORMATEX#,18
 dim child_MMCKINFO#,20
 dim parent_MMCKINFO#,20

 clear DSBUFFERDESC#
 long DSBUFFERDESC#,0  = 20
 long DSBUFFERDESC#,4  = 209
 long DSBUFFERDESC#,8  = 0
 long DSBUFFERDESC#,16 = 0

 let hr& = Call(@long(vp_dsound&,12),IDirectSound&,DSBUFFERDESC#,Addr(DSBPrimary&),0) 'CreateSoundBuffer

 if @neq(hr&,0)
  return hr&
 endif

 let vp_primaryb& = @long(DSBPrimary&,0)

 return hr&

endproc
'+++

proc DSInitFromProSpeed

 DEF __DSoundGetInterfaces(1) !"ProSpeed","DSoundGetInterfaces"

 let IDirectSound& = __DSoundGetInterfaces(Addr(DSBPrimary&))
 let vp_dsound& = @long(IDirectSound&,0)
 let vp_primaryb& = @long(DSBPrimary&,0)

 Call(@long(vp_dsound&,4),IDirectSound&) 'AddRef
 Call(@long(vp_primaryb&,4),DSBPrimary&) 'AddRef

 dim DSBUFFERDESC#,20
 dim WAVEFORMATEX#,18
 dim child_MMCKINFO#,20
 dim parent_MMCKINFO#,20

 return 0

endproc
'+++

proc DSDeInit

 Call(@long(vp_primaryb&,60),DSBPrimary&,0) 'SetVolume
 Call(@long(vp_primaryb&,64),DSBPrimary&,0) 'SetPan

 Call(@long(vp_primaryb&,8),DSBPrimary&) 'Release
 Call(@long(vp_dsound&,8),IDirectSound&) 'Release

 dispose DSBUFFERDESC#
 dispose WAVEFORMATEX#
 dispose child_MMCKINFO#
 dispose parent_MMCKINFO#

endproc
'+++

proc DSLoadSound
parameters file$

 declare DSBuffer&,vp_buffer&
 declare buffer1&,buffer2&
 declare bufferSize&,bytesToWrite&,size1&,size2&,bytesWritten&
 declare hmmio&,flags&
 declare hr&

 let hmmio& = mmioOpen(Addr(file$),0,65536)

 if @equ(hmmio&,0)
  return 0
 endif

 clear child_MMCKINFO#,parent_MMCKINFO#,WAVEFORMATEX#

 long parent_MMCKINFO#,0  = 1163280727 'mmioFOURCC('W','A','V','E')
 long child_MMCKINFO#,0  = 54450194 'mmioFOURCC('f','m','t',' ')

 mmioDescend(hmmio&,parent_MMCKINFO#,0,32) '32 = MMIO_FINDRIFF
 mmioDescend(hmmio&,child_MMCKINFO#,parent_MMCKINFO#,0)
 mmioRead(hmmio&,WAVEFORMATEX#,18)

 word WAVEFORMATEX#,16 = 0

 if @neq(@word(WAVEFORMATEX#,0),1) '1 = WAVE_FORMAT_PCM
  return 0
 endif

 mmioAscend(hmmio&,child_MMCKINFO#,0)
 long child_MMCKINFO#,0  = 1635017060 'mmioFOURCC('d','a','t','a')
 mmioDescend(hmmio&,child_MMCKINFO#,parent_MMCKINFO#,16) '16 = MMIO_FINDCHUNK

 let bufferSize& = @long(child_MMCKINFO#,4)

 clear DSBUFFERDESC#

 long DSBUFFERDESC#,0  = 20
 long DSBUFFERDESC#,4  = 226
 long DSBUFFERDESC#,8  = bufferSize&
 long DSBUFFERDESC#,16 = WAVEFORMATEX#

 let hr& = Call(@long(vp_dsound&,12),IDirectSound&,DSBUFFERDESC#,Addr(DSBuffer&),0) 'CreateSoundBuffer

 if @neq(hr&,0)
  return 0
 endif

 let vp_buffer& = @long(DSBuffer&,0)

 let bytesToWrite& = @sub(bufferSize&,1)
 let flags& = 0

 Call(@long(vp_buffer&,44),DSBuffer&,0,bytesToWrite&, \
      Addr(buffer1&),Addr(size1&), \
      Addr(buffer2&),Addr(size2&),flags&) 'Lock

 if @neq(buffer1&,0)
  mmioRead(hmmio&,buffer1&,size1&)
 endif

 if @neq(buffer2&,0)
  mmioRead(hmmio&,buffer2&,size2&)
 endif

 Call(@long(vp_buffer&,76),DSBuffer&,buffer1&,size1&,buffer2&,size2&) 'Unlock

 mmioClose(hmmio&,0)

 return DSBuffer&

endproc
'+++

proc DSReleaseSound
parameters DSBuffer&

 declare vp_buffer&,flags&
 let vp_buffer& = @long(DSBuffer&,0)

 Call(@long(vp_buffer&,8),DSBuffer&) 'Release

endproc
'+++

proc DSPlaySound
parameters DSBuffer&,loop%

 declare vp_buffer&,flags&
 let vp_buffer& = @long(DSBuffer&,0)

 if loop%
  let flags& = 1
 else
  let flags& = 0
 endif

 return Call(@long(vp_buffer&,48),DSBuffer&,0,0,flags&) 'Play

endproc
'+++

proc DSStopSound
parameters DSBuffer&

 declare vp_buffer&
 let vp_buffer& = @long(DSBuffer&,0)

 return Call(@long(vp_buffer&,72),DSBuffer&) 'Stop

endproc
'+++

proc DSSetVolume
parameters DSBuffer&,volume&

 declare vp_buffer&
 let vp_buffer& = @long(DSBuffer&,0)

 return Call(@long(vp_buffer&,60),DSBuffer&,volume&) 'SetVolume

endproc
'+++

proc DSSetGlobalVolume
parameters volume&

 return Call(@long(vp_primaryb&,60),DSBPrimary&,volume&) 'SetVolume

endproc
'+++

proc DSSetPan
parameters DSBuffer&,pan&

 declare vp_buffer&
 let vp_buffer& = @long(DSBuffer&,0)

 return Call(@long(vp_buffer&,64),DSBuffer&,pan&) 'SetPan

endproc
'+++

proc DSSetGlobalPan
parameters pan&

 return Call(@long(vp_primaryb&,64),DSBPrimary&,pan&) 'SetPan

endproc
'+++

proc DSDuplicate
parameters DSBuffer&

 declare newBuffer&
 Call(@long(vp_dsound&,20),IDirectSound&,DSBuffer&,Addr(newBuffer&))

 return newBuffer&

endproc
'+++
